
classdef Lambda < form
    properties
        x0;
    end
    methods 
        function ld = Lambda(x0, Vs) 
            if ~isa(Vs,'vectorSpace') || ~check_xInDomain(Vs.domain,x0)
                error('x0 is not in the domain of the function system');
            end
            ld@form(Vs);
            ld.x0 = x0;
        end
        function ev = at(ld,f)
            if ~isa(f,'func') || f.domain~=Vs.domain || f.range~=Vs.range
                error('f is not a function in the function space');
            end
            ev = f.at(ld.x0);
        end
    end
end