% monomial basis on the reference

classdef Monombasis < indepFuncSys
    properties
        dg;
        p;
    end
    methods 
        function ml = Monombasis(dm,rg,dg)
            if ~isa(dm, 'triangulation')
                error('The monomil basis is on the segment (now only for 1D)');
            end
            if ~isa(rg,'field')
                error('The function range is a field');
            end
            if ~isinteger(int8(dg)) || length(dg)~=1
                error('The degree of the monomials must be a integer');
            end
            g = cell(dg+1,1);
            for k=0:dg
                g{k+1} = func(dm,rg, @(x) x.^k, {@(x) k*x.^(k-1)}); 
            end
            V = vectorSpace(dm,rg);
            fcnal = cell(dg+1,1); 
            for k=0:dg
                fcnal{k+1} = delta(k/dg, V);
            end
            ml@indepFuncSys(g, fcnal);
            ml.dg = dg;
            ml.p = [0:dg]/dg;
        end
    end
end