classdef basis
    properties(SetAccess=protected, GetAccess=public)
        id;   % identification 
        dim;  % dimension 
    end
    %
    methods
        function b = basis(id,dim)
            if ~isa(dim,'numeric') || dim<=0 || dim~=floor(dim)
                error('Dimension of the basis must be a positive integer.');
            end
            if ~isa(id,'handle')
                error('basis id is the handle of a function system');
            end
            b.id = id;
            b.dim = dim;
        end
        %
        %function idnum = get.id(this)
        %    idnum = this.id;
        %end
  
        % overloading ==
        function b = eq(this,B)
            b = isa(B,'basis') && isequal(this.id, B.id);
        end
        % overloading ~=
        function b = ne(this,B)
            b = ~(this==B);
        end

        % overloading display
        %function display(this)
            % how to print a handle
            %fprintf('basis %s\n',char(this.id));
        %end      
    end
end        