        % check if the given point is in a domain
        
        function [xin,varargout] = check_xInDomain(dm, x, varargin)
            if ~isa(dm,'triangulation') || ~isa(x,'numeric') 
                error('Here is to check if x in the given triangulation');
            end 
             
            if size(x,2) ~= dm.dim
                x= x';
            end  
            
            nT = zeros(size(x,1),1);
            xin = zeros(size(x,1),1);  
            sx = zeros(size(x));  
 
            
            if size(x,2) == dm.dim 
              if isempty(varargin)
                  check_cells = 1:dm.ncell; 
              else
                  check_cells = reshape(varargin{1},1,numel(varargin{1})); 
              end
              
                for xi = 1:size(x,1)
                    x0 = x(xi,:);
                    for k = check_cells 
                     % check if x0 in the cell k,
                     % yes, the corresponding position s in the reference cell
                     %      is in [0,1]^d 
                     s = dm.get_xInRef(k, x0);
                     if ~sum(s<0) && sum(s)<=1  
                        xin(xi) = 1; 
                        nT(xi) = k;
                        sx(xi,:) = s;
                        break;
                     end   
                    end
                end
            end
            
            varargout{1} = nT;
            varargout{2} = sx;  
        end %function
