% Create the general linear mapping 

classdef linearForm
    properties
        b;
        Bs;
    end
    %
    methods
        function L = linearForm(Bs, b)
            if ~isa(b,'vector') ||~isa(Bs,'basis') || b.Bs~=Bs
                error('The linear mapping must be a vector');
            end 
            L.b = reshape(b.c, 1, Bs.dim);
            L.Bs = Bs;
        end
        %
        function z = apply(L,u) 
            if ~isa(u,'vector') || u.Bs~=L.Bs
                error('The linear mapping cannot apply to the given vector');
            end
            z=L.f*u.c;
        end
    end
end