
% This is a 1D program for finite elemente method 
 close all
 clear classes

 

g = @(x)(sin(pi*x));
u = @(x)(cos(pi*x));
 

%test pointMeasure
A = Measure.gaussLegend(10);
A.integral(g)

B = Measure.gaussJacob(1,10);
B.integral(g)

%--------------------------------------------------
%test triangulation

% create two possible reference cells
pt = point(); 
sg = segment();

% create a triangulation with 2 nodes and one cell
nodes = [0;1];
ems = [1,2];
ref = sg;
t1 = triangulation1D(nodes,ems,ref);

% create a triangulation with nodes (index in order)
x=[0,1,2,3];  
elms = [1,2; 2,3; 3,4];
ref = sg;
tr2 = triangulation1D(x,elms,ref);

% create a triangulation with nodes (disordered)
x=[0,3,1,2];
em = [1,3; 4,2; 3,4];
ref = sg;
tr3 = triangulation1D(x, em, ref);

%---------------------------------------------
%test function space

x = [3.4, 2.7, -7.8, 2i];

R = field('R');
R.in(x)

C = field('C');
C.in(x)
in(C,x)

dm = triangulation(2);

g0 = @(x)(sum(x.^2,2));
f = func(dm, R, g0);
x = [1,2; 0,2; 3,0];
f.at(x)
f.at(x')
f.derivative(1)
f.derivative(2)

dg1 = @(x)(2*x(:,1));
dg2 = @(x)(2*x(:,2)); 
df = {dg1,dg2};
f = func(dm,R, g0, df);
df1 = f.derivative(1);
df1.at(x)
df2 = f.derivative(2); 

dm = triangulation(5);
g = cell(dm.dim,1);
for k = 1:dm.dim
    g{k} = func(dm,R,@(x)(x(:,k)==k));
end
S = funcSys(dm.dim,g);

%-------------------------------------------
%test funcSys with real triangulation

%independent function system: monomials
% only done for reference segment 
monoRef = Monombasis(sg, R, 2); 

[ons, nT, sx]=check_xInDomain(tr2, [0.5,1.5]);

%independent function system P_t
p1 = ptBasis(tr2, R, 1);
p2 = ptBasis(tr2, R, 2);
p3 = ptBasis(tr3, R, 1);

%display basis functions
 p2.plot_funcSys()
%display 2nd basis function and its derivative
 p2.funcs{2}.plot_func
 p2.funcs{2}.d{1}.plot_func

Q = Measure.gaussLegend(5);
f = func(tr2, R, @(x) sin(x));

% use p1-element 
V = solutionSpace(tr2,R, 1);
fv = L2product(V,f,Q);
auv = laplace(V,Q);

dom = [0,1];
N=11;
bctyp={'Dirichlet', 'Neumann'};
bcpos={[0,1], []};  % two ends of the dom are Dirichlet boundary nodes.

grid1 = tri1D(dom,N, bctyp, bcpos);


