
classdef monomial < indepFuncSys
    properties
        dg;
    end
    methods 
        function ml = monomial(dm,rg,dg)
            if ~isa(dm, 'triangulation')
                error('The domain is a triangulation');
            end
            if ~isa(rg,'field')
                error('The function range is a field');
            end
            if ~isinteger(int8(dg)) || length(dg)~=1
                error('The degree of the monomials must be a integer');
            end
            g = cell(dg+1,1);
            for k=0:dg
                g{k+1} = func(dm,rg,@(x) x.^k);
            end
            ml@indepFuncSys(dg+1,g);
            ml.dg = dg;
        end
    end
end