
classdef tri1D < triangulation1D
    properties
        Dirichlet;
        Neumann;
        Robin;
        h;
    end
    methods
        function tr = tri1D(xe, N, bctyp,bcpos)
            if ~isa([xe,N],'numeric')
                error('xe=(a,b) is the 1D domain, h is grid size');
            end
            if length(bctyp)~=length(bcpos)
                error('the boundary condition is not given properly');
            end
            x = linspace(xe(1),xe(2),N);  
            cell = [1:length(x)-1; 2:length(x)]';
            sg = segment();
            tr@triangulation1D(x', cell, sg);
            tr.h = x(2)-x(1);
            [y,ind]=ismember({'Dirichlet', 'Neumann','Robin'}, bctyp);
            if y(1)
               bcnode = bcpos{ind(1)};
               bcindex = zeros(size(bcnode));
               for k = 1: numel(bcnode) 
                   I=find(abs(x-bcnode(k))<1e-6); 
                   bcindex(k) = I;
               end
               tr.Dirichlet = bcindex; 
            end
             
        end
    end
end
            
            