%function space F(domain,K) with Basis

classdef vectorSpace
    properties 
        range;
        domain;   
        Bs;
        dim;
        zero;
    end
    methods
        function vs = vectorSpace(domain, range, varargin)
            if ~isa(domain,'triangulation') || ~isa(range,'field')
                error('The function space is all mappings from domain to the range');
            end 
            if ~isempty(varargin) && isa(varargin{1}, 'indepFuncSys')
               vs.dim = varargin{1}.nfunc;
               vs.Bs = basis(varargin{1}, vs.dim); 
               vs.zero = vector(vs.Bs, zeros(1,vs.dim));
            else
                display('The basis is not yet given');
            end
            vs.range = range;
            vs.domain = domain;
        end
        %?
        % the remaining questions: how to check two equivalent basis 
        %                          how to get a Basis from a Spawn system
        %?
        function s = eq(this,u)
            if ~isa(this,'vectorSpace') || ~isa(u,'vectorSpace')
                error('The arguments are two vector space');
            end 
            s = (this.domain==u.domain) && (this.range==u.range);
        end
        %
        function fin = in(vs, f)
            if ~isa(vs,'vectorSpace')
                error('The first argument is a function space');
            end
            if ~isa(f,'func')
                error('The second argument is a function');
            end
            fin = 1;
            if f.domain~=vs.domain || f.range~=vs.range
                fin = 0;
            end
            %not finished, how to judge the function in this space
        end
        %
        function f = vector2func(vs, c)
            if ~isa(vs,'vectorSpace') || ~isa(c,'vector') || vs.Bs~=c.Bs
                error('The vector is not an element of the given function space');
            end
       
            f = c.c(1)*vs.Bs.id.funcs{1};  
            for k=2:numel(c.c)
                f = f + c.c(k)*vs.Bs.id.funcs{k};
            end 
        end
    %
        function bs = get_dualbasis(vs,M)
            if ~isa(vs,'vectorSpace')
               error('The dual basis can only be obtained for the basis of a vector space');
            end
            if ~isequal(size(M),[vs.Bs.id.nfunc,vs.Bs.id.nfunc])
               error('The van der Monde matrix of the dual basis is wrongly given');
            end
            
            % M is the van der Monde Matrix of the dual basis
            
            bs= M/vs.Bs.id.vdM;
        end
    end
end